/* BdfServer_Html - Copyright (c) 2017-2021 Vincent Calame - Exemole
 * Logiciel libre donné sous triple licence :
 * 1) selon les termes de la CeCILL V2
 * 2) selon les termes de l’EUPL V.1.1
 * 3) selon les termes de la GNU GPLv3
 * Voir le fichier licences.txt
 */


package fr.exemole.bdfserver.html.jslib;

import net.mapeadores.util.annotation.Nullable;


/**
 *
 * @author Vincent Calame
 */
public class JsrenderTemplateFamily {

    public final static short CORE_TYPE = 1;
    public final static short EXTENSION_TYPE = 2;
    public final static short APP_TYPE = 3;
    private final String familyName;
    private final short originType;
    private final String originName;


    public JsrenderTemplateFamily(String familyName) {
        this.familyName = familyName;
        this.originType = CORE_TYPE;
        this.originName = null;
    }

    public JsrenderTemplateFamily(String familyName, short originType, String originName) {
        this.familyName = familyName;
        this.originType = originType;
        this.originName = originName;
    }

    public String getName() {
        return familyName;
    }

    public short getOriginType() {
        return originType;
    }

    @Nullable
    public String getOriginName() {
        return originName;
    }

}
