/* BdfServer_Multi - Copyright (c) 2020-2022 Vincent Calame - Exemole
 * Logiciel libre donné sous triple licence :
 * 1) selon les termes de la CeCILL V2
 * 2) selon les termes de l’EUPL V.1.1
 * 3) selon les termes de la GNU GPLv3
 * Voir le fichier licences.txt
 */


package fr.exemole.bdfserver.multi.commands;

import fr.exemole.bdfserver.api.BdfServer;
import fr.exemole.bdfserver.multi.Multi;
import net.mapeadores.util.logging.CommandMessage;
import net.mapeadores.util.logging.ErrorMessageException;
import net.mapeadores.util.logging.LogUtils;
import net.mapeadores.util.request.RequestMap;


/**
 *
 * @author Vincent Calame
 */
public class FichothequeInitCommand extends AbstractMultiCommand {

    public final static String COMMAND_NAME = "FichothequeInit";
    public final static String NAME_PARAMNAME = "name";

    public FichothequeInitCommand(Multi multi, RequestMap requestMap) {
        super(multi, requestMap);
    }

    @Override
    public CommandMessage doCommand() throws ErrorMessageException {
        String name = run();
        return LogUtils.done("_ done.multi.fichothequeinit", name);
    }

    private String run() throws ErrorMessageException {
        String name = getFichothequeName(NAME_PARAMNAME);
        BdfServer bdfServer = multi.getBdfServer(name);
        if (bdfServer == null) {
            throw new ErrorMessageException("_ error.unknown.fichotheque", name);
        }
        return name;
    }

}
