/* BdfServer_Multi - Copyright (c) 2018-2020 Vincent Calame - Exemole
 * Logiciel libre donné sous triple licence :
 * 1) selon les termes de la CeCILL V2
 * 2) selon les termes de l’EUPL V.1.1
 * 3) selon les termes de la GNU GPLv3
 * Voir le fichier licences.txt
 */


package fr.exemole.bdfserver.multi.htmlproducers;

import fr.exemole.bdfserver.html.jslib.AdminJsLibs;
import fr.exemole.bdfserver.multi.Multi;
import net.mapeadores.util.html.HA;
import net.mapeadores.util.html.JsObject;


/**
 *
 * @author Vincent Calame
 */
public class AdminHtmlProducer extends MultiHtmlProducer {

    public AdminHtmlProducer(Multi multi) {
        super(multi);
        addJsLib(AdminJsLibs.MULTI);
        addThemeCss("pane.css", "multi.css");
    }

    @Override
    public void printHtml() {
        JsObject multiArgs = JsObject.init()
                .put("authentificationSharingAllowed", multi.isAuthentificationSharingAllowed());
        startLoc("_ title.multi.index");
        this
                .SCRIPT()
                .__jsObject("Multi.ARGS", multiArgs)
                ._SCRIPT();
        this
                .DIV(HA.id("layout"))._DIV();
        end();
    }

}
