/* global BDF,$$s */
/**
 * Objet global définissant l'espace de nom ScrutariExport
 * 
 * @namespace ScrutariExport
 */
var ScrutariExport = {};

ScrutariExport.subsetTrees = null;
ScrutariExport.array = null;


/******************************************************************************
 * Actions sur ScrutariExport
 ******************************************************************************/

ScrutariExport.initArray = function (array) {
    for(let scrutariExportObj of array) {
        ScrutariExport.completeScrutariExport(scrutariExportObj);
    }
    ScrutariExport.array = array;
    return array;
};

ScrutariExport.getScrutariExport = function (scrutariExportName) {
    for(let scrutariExport of ScrutariExport.array) {
        if (scrutariExport.name === scrutariExportName) {
            return scrutariExport;
        }
    }
    return null;
};

ScrutariExport.updateScrutariExport = function (newScrutariExport) {
    newScrutariExport = ScrutariExport.completeScrutariExport(newScrutariExport);
    BDF.updateInArray(ScrutariExport.array, newScrutariExport);
    ScrutariExport.List.updateScrutariExport(newScrutariExport);
    return newScrutariExport;
};

ScrutariExport.removeScrutariExport = function (name) {
    BDF.removeInArray(ScrutariExport.array, name);
    BDF.Pane.removeContents(name);
    BDF.Pane.removeEntry($$("listpane_body"), name);
};

ScrutariExport.insertScrutariExport = function (scrutariExport) {
    scrutariExport = ScrutariExport.completeScrutariExport(scrutariExport);
    BDF.insertInArray(ScrutariExport.array, scrutariExport);
    var $entry = BDF.Pane.insertEntry($$("listpane_body"), scrutariExport.name, BDF.render("scrutariexport:list-scrutariexport", scrutariExport));
    $$("listpane_body").animate({
        scrollTop: $entry.offset().top
    }, 1000, function () {
        BDF.Deploy.ensureLinkVisibility($entry, true);
    });
    ScrutariExport.Form.load(scrutariExport.name);
    return scrutariExport;
};

ScrutariExport.completeScrutariExport = function (scrutariExportObj) {
    var scrutariExportName = scrutariExportObj.name;
    return scrutariExportObj;
};


/******************************************************************************
 * Enregistrement de fonction
 ******************************************************************************/

BDF.Pane.registerCheckFunction(function (state) {
    $(".pane-list-ActiveItem").removeClass("pane-list-ActiveItem");
    if (state.withMain()) {
        let $scrutariExport = BDF.$({role: "entry", name: state.mainContentKey});
        BDF.$($scrutariExport, {role: "entry-header"}).addClass("pane-list-ActiveItem");
    }
});


/******************************************************************************
 * Initialisation
 ******************************************************************************/

$(function () {
    BDF.initTemplates();
    BDF.Pane.initLayout();
    BDF.Deploy.addVisibilityListener(_visibilityListener);
    $$("layout_list").html(BDF.render("scrutariexport:list-pane", {}));
    BDF.initBeforeUnload();
    BDF.runSerialFunctions(
        BDF.initLangConfiguration,
        BDF.initPathConfiguration,
        _initSubsetTrees,
        _initMemento,
        ScrutariExport.List.init
    );
    
    
    function _initSubsetTrees(callback) {
        BDF.Pane.loadSubsetTrees(function (subsetTrees) {
            ScrutariExport.subsetTrees = subsetTrees;
            if (callback) {
                callback();
            }
        });
    }
    
    function _initMemento(callback) {
        BDF.Pane.loadMemento("xml/memento/tableexport", function () {
            if (callback) {
                callback();
            }
        });
    }
    
    function _visibilityListener(element, visible) {
        if (visible) {
            BDF.refreshCodeMirror(element);
        }
    };
    
});