/* FichothequeLib_API - Copyright (c) 2006-2021 Vincent Calame - Exemole
 * Logiciel libre donné sous triple licence :
 * 1) selon les termes de la CeCILL V2
 * 2) selon les termes de l’EUPL V.1.1
 * 3) selon les termes de la GNU GPLv3
 * Voir le fichier licences.txt
 */


package net.fichotheque.selection;

import java.util.List;
import net.fichotheque.SubsetKey;
import net.mapeadores.util.annotation.Nullable;
import net.mapeadores.util.primitives.Ranges;


/**
 *
 * @author Vincent Calame
 */
public interface FicheQuery {

    public final static String ALL_DISCARDFILTER = "all";
    public final static String NONE_DISCARDFILTER = "none";
    public final static String ONLY_DISCARDFILTER = "only";
    public final static String ALL_REDACTEURFILTER = "all";
    public final static String NONE_REDACTEURFILTER = "none";
    public final static String ANY_REDACTEURFILTER = "any";
    public final static String SOME_REDACTEURFILTER = "only";

    public List<SubsetKey> getCorpusKeyList();

    @Nullable
    public Ranges getIdRanges();

    public MotcleCondition getMotcleCondition();

    @Nullable
    public FieldQuery getFieldQuery();

    public String getRedacteurFilter();

    public List<String> getRedacteurGlobalIdList();

    public List<SubsetKey> getSphereKeyList();

    public boolean isWithRattachement();

    @Nullable
    public PeriodCondition getPeriodCondition();

    public String getDiscardFilter();

    public boolean isWithCurrentCorpus();

    public boolean isWithGeoloc();

}
