/* UtilLib - Copyright (c) 2006-2014 Vincent Calame - Exemole
 * Logiciel libre donné sous triple licence :
 * 1) selon les termes de la CeCILL V2
 * 2) selon les termes de l’EUPL V.1.1
 * 3) selon les termes de la GNU GPLv3
 * Voir le fichier licences.txt
 */


package net.mapeadores.util.xml;

import java.io.IOException;


/**
 *
 * @author Vincent Calame
 */
public interface XMLWriter {

    public void startOpenTag(String name) throws IOException;

    public void startOpenTag(String name, boolean indentBefore) throws IOException;

    public void endOpenTag() throws IOException;

    public void closeEmptyTag() throws IOException;

    public void openTag(String name) throws IOException;

    public void openTag(String name, boolean indentBefore) throws IOException;

    public void closeTag(String name) throws IOException;

    public void closeTag(String name, boolean indentBefore) throws IOException;

    public void addText(CharSequence charSequence) throws IOException;

    public void addCData(CharSequence charSequence) throws IOException;

    public void addAttribute(String attributeName, String value) throws IOException;

    public void addAttribute(String attributeName, int i) throws IOException;

    /**
     * N'insère rien si value est nul ou de longueur nulle
     */
    public void addSimpleElement(String name, String value) throws IOException;

    public void addEmptyElement(String name) throws IOException;

}
